#include <QApplication>
#include <QToolBar>
#include <QToolButton>
#include <QMenu>
#include <QTabWidget>
#include <QVBoxLayout>
#include <QMainWindow>
#include <QWidgetAction>


QTabWidget*createTab(const QString&tabName)
{
    auto*widget=new QWidget();
    widget->setMinimumSize(200,100);
    widget->setContextMenuPolicy(Qt::CustomContextMenu);
    auto*menu=new QMenu(widget);
    menu->addAction("Where do you see me?");
    QObject::connect(widget,&QWidget::customContextMenuRequested,[menu,widget](const QPoint&pos){
        menu->move(widget->mapToGlobal(pos));
        menu->show();});
    auto*tab=new QTabWidget();
    tab->addTab(widget,tabName);
    return tab;
}

QWidget*createTabs()
{
    auto*widget2=new QWidget();
    auto*layout=new QVBoxLayout();
    layout->addWidget(createTab("Tab1"));
    layout->addWidget(createTab("Tab2"));
    auto*widget=new QWidget();
    widget->setLayout(layout);
    return widget;
}

int main(int argc,char**argv)
{
    QApplication app(argc,argv);
    QMenu menu;
    auto*tabsAction=new QWidgetAction(&menu);
    tabsAction->setDefaultWidget(createTabs());
    menu.addAction(tabsAction);
    auto*button=new QToolButton();
    button->setText("Press Here");
    button->setMenu(&menu);
    button->setPopupMode(QToolButton::InstantPopup);
    QMainWindow window;
    window.setWindowTitle("Bug Repro");
    window.addToolBar("toolbar")->addWidget(button);
    window.setCentralWidget(createTabs());
    window.show();
    app.exec();
    return 0;
}
